Package org.gradle.api.tasks

# Class Exec

java.lang.Object
org.gradle.api.internal.AbstractTask
org.gradle.api.DefaultTask
org.gradle.api.internal.ConventionTask
org.gradle.api.tasks.AbstractExecTask<Exec>
org.gradle.api.tasks.Exec

All Implemented Interfaces:
  `Comparable<Task>`, `org.gradle.api.internal.DynamicObjectAware`, `org.gradle.api.internal.IConventionAware`, `org.gradle.api.internal.TaskInternal`, `Named`, `ExtensionAware`, `Task`, `BaseExecSpec`, `ExecSpec`, `ProcessForkOptions`, `Configurable<Task>`

@DisableCachingByDefault(because="Gradle would require more information to cache this task") public abstract class Exec extends AbstractExecTask<Exec>
Executes a command line process. Example:

     task stopTomcat(type:Exec) {
       workingDir '../tomcat/bin'

       //on windows:
       commandLine 'cmd.exe', '/d', '/c', 'stop.bat'

       //on linux
       commandLine './stop.sh'

       //store the output instead of printing to the console:
       standardOutput = new ByteArrayOutputStream()

       //extension method stopTomcat.output() can be used to obtain the output:
       ext.output = {
         return standardOutput.toString()
       }
     }

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `(package private) static class`
  `Exec.ArgsAdapter`
  No need to upgrade getter since it's already upgraded via ExecSpec
  `(package private) static class`
  `Exec.ErrorOutputAdapter`
  No need to upgrade getter since it's already upgraded via BaseExecSpec
  `(package private) static class`
  `Exec.IgnoreExitValueAdapter`
  No need to upgrade getter since it's already upgraded via BaseExecSpec
  `(package private) static class`
  `Exec.StandardInputAdapter`
  No need to upgrade getter since it's already upgraded via BaseExecSpec
  `(package private) static class`
  `Exec.StandardOutputAdapter`
  No need to upgrade getter since it's already upgraded via BaseExecSpec

  ## Nested classes/interfaces inherited from interface org.gradle.api.Named

  `Named.Namer`

- ## Field Summary

  ### Fields inherited from interface org.gradle.api.Task

  `TASK_ACTION, TASK_CONSTRUCTOR_ARGS, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Exec()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ListProperty<String>`
  `getArgs()`
  Returns the arguments for the command to be executed.
  `Property<OutputStream>`
  `getErrorOutput()`
  Returns the output stream to consume standard error from the process executing the command.
  `Property<Boolean>`
  `getIgnoreExitValue()`
  Tells whether a non-zero exit value is ignored, or an exception thrown.
  `Property<InputStream>`
  `getStandardInput()`
  Returns the standard input stream for the process executing the command.
  `Property<OutputStream>`
  `getStandardOutput()`
  Returns the output stream to consume standard output from the process executing the command.

  ### Methods inherited from class org.gradle.api.tasks.AbstractExecTask

  `args, args, commandLine, commandLine, copyTo, environment, environment, exec, executable, getArgumentProviders, getCommandLine, getEnvironment, getExecActionFactory, getExecutable, getExecutionResult, getIsIgnoreExitValue, getObjectFactory, getWorkingDir, workingDir`

  ### Methods inherited from class org.gradle.api.internal.ConventionTask

  `conventionMapping, conventionMapping, getConventionMapping`

  ### Methods inherited from class org.gradle.api.DefaultTask

  `compareTo, configure, dependsOn, doFirst, doFirst, doFirst, doLast, doLast, doLast, finalizedBy, getActions, getAnt, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExtensions, getFinalizedBy, getGroup, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOutputs, getPath, getProject, getShouldRunAfter, getState, getTaskDependencies, getTemporaryDir, getTimeout, hasProperty, mustRunAfter, onlyIf, onlyIf, onlyIf, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setFinalizedBy, setGroup, setMustRunAfter, setOnlyIf, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, usesService`

  ### Methods inherited from class org.gradle.api.internal.AbstractTask

  `acceptServiceReferences, appendParallelSafeAction, doNotTrackState, doNotTrackStateIf, getAsDynamicObject, getIdentityPath, getImpliesSubProjects, getLifecycleDependencies, getOnlyIf, getReasonNotToTrackState, getReasonsNotToTrackState, getReasonTaskIsIncompatibleWithConfigurationCache, getRequiredServices, getServices, getSharedResources, getStandardOutputCapture, getTaskActions, getTaskIdentity, getTemporaryDirFactory, hasTaskActions, injectIntoNewInstance, isCompatibleWithConfigurationCache, isEnabled, isHasCustomActions, notCompatibleWithConfigurationCache, prependParallelSafeAction, restoreOnlyIf, restoreTaskActions, setImpliesSubProjects`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.gradle.api.Task

  `doNotTrackState, notCompatibleWithConfigurationCache`

- ## Constructor Details

  - ### Exec

    public Exec()

- ## Method Details

  - ### getArgs

    public ListProperty<String> getArgs()
    Returns the arguments for the command to be executed. Defaults to an empty list.
    Specified by:
      `getArgs` in interface `ExecSpec`
    Overrides:
      `getArgs` in class `AbstractExecTask<Exec>`

  - ### getIgnoreExitValue

    public Property<Boolean> getIgnoreExitValue()
    Tells whether a non-zero exit value is ignored, or an exception thrown. Defaults to `false`.
    Specified by:
      `getIgnoreExitValue` in interface `BaseExecSpec`
    Overrides:
      `getIgnoreExitValue` in class `AbstractExecTask<Exec>`
    Returns:
      whether a non-zero exit value is ignored, or an exception thrown

  - ### getStandardInput

    public Property<InputStream> getStandardInput()
    Returns the standard input stream for the process executing the command. The stream is closed after the process completes. Defaults to an empty stream.
    Specified by:
      `getStandardInput` in interface `BaseExecSpec`
    Overrides:
      `getStandardInput` in class `AbstractExecTask<Exec>`
    Returns:
      The standard input stream.

  - ### getStandardOutput

    @Internal public Property<OutputStream> getStandardOutput()
    Returns the output stream to consume standard output from the process executing the command. Defaults to `System.out`.
    Specified by:
      `getStandardOutput` in interface `BaseExecSpec`
    Overrides:
      `getStandardOutput` in class `AbstractExecTask<Exec>`
    Returns:
      The output stream

  - ### getErrorOutput

    public Property<OutputStream> getErrorOutput()
    Returns the output stream to consume standard error from the process executing the command. Default to `System.err`.
    Specified by:
      `getErrorOutput` in interface `BaseExecSpec`
    Overrides:
      `getErrorOutput` in class `AbstractExecTask<Exec>`
    Returns:
      The error output stream.